#ifndef VNET_YARP_ADMIN_HH_
#define VNET_YARP_ADMIN_HH_

#include <yarp/os/all.h>

#include <map>
#include <boost/function.hpp>
#include <boost/noncopyable.hpp>


namespace vnet {
	namespace yarp {

		class table;
		class filter_factory;

		class admin : public boost::noncopyable {
			typedef boost::function<bool (const ::yarp::os::Bottle&)> dispatch_proto;
			typedef std::map<std::string, dispatch_proto> dispatch_table;

			table& m_table;
			filter_factory& factory;
			dispatch_table dispatch;
			bool quit_;
			::yarp::os::BufferedPort< ::yarp::os::Bottle>  in, out;

			private:
				bool add(const ::yarp::os::Bottle& b);
				bool print(const ::yarp::os::Bottle& b);
				bool quit(const ::yarp::os::Bottle& b);
				bool rm(const ::yarp::os::Bottle& b);
				bool clear(const ::yarp::os::Bottle& b);

			public:
				admin(table& m_table, filter_factory& factory);
				bool process();
				void process_all();
				void quit() { quit_  = true; }
		};
	}
}

#endif /* VNET_YARP_ADMIN_HH */
