#include <vnet_filter.hh>
#include <vnet_filter_pass.hh>
#include <vnet_filter_block.hh>
#include <vnet_filter_random.hh>
#include <vnet_filter_morse.hh>

using namespace vnet::yarp;

filter_factory::filter_factory() 
{
	register_filter<filter_pass>("pass");
	register_filter<filter_block>("block");
	register_filter<filter_random>("random");
	register_filter<filter_morse>("morse");
}

filter_base* filter_factory::make_filter(const std::string& s, 
										 const std::vector<std::string>& argv)
{
	if (factory_.find (s) == factory_.end ())
		return NULL;
	else
		factory_[s](argv);
}
